//
// C++ Implementation: yawp
//
// Description:
//
//
// Author: Ruan <ruans@kr8.co.za>, (C) 2008
//
// Copyright: Do what you want, whenever you want.
//
//
#ifndef YAWP_H
#define YAWP_H


#include <Plasma/Applet>
#include <Plasma/Svg>

class YaWPConfigDialog;
class YaWPDay;
class YaWPWeatherServiceRunner;
class QTimer;
class YaWPWeatherService;

//-----------------------------------------------------------------------------
/** Main plasmoid class.
@author Ruan <ruans@kr8.co.za>
*/
class YaWP : public Plasma::Applet
{
    Q_OBJECT
    public:
        
        YaWP(QObject *parent, const QVariantList &args);
        
        virtual ~YaWP();
        
        void paintInterface(QPainter *painter, const QStyleOptionGraphicsItem *option, const QRect& contentsRect);
        
        void init();
        
        void loadConfig();
        
        void saveConfig();
        
        void showConfigurationInterface();
        
        void constraintsEvent(Plasma::Constraints constraints);
        
    protected slots:
        void timeout();
        
        void settingsChanged();
        
        void updateMessage(QString mess);
        
        void updateInfo(QObject *, int);
        
    private:
        void paintDesktop(QPainter *p, const QRect &contentsRect);
        void paintPanel(QPainter *p, const QRect &contentsRect);
        
        Plasma::Svg         m_svg;
        YaWPConfigDialog    *m_cdiag;
        QFont               m_font;
        QTimer              *m_timer;
        QString             m_message;
        int                 m_interval;
        bool                m_inpanel;
        
        QString             m_theme;
        QString             m_city;
        QString             m_country;
        QString             m_service;
        int                 m_units;
        
        QVector<YaWPDay>    m_days;

        YaWPWeatherService * m_wservice;
};


#endif
