//
// C++ Implementation: yawp
//
// Description:
//
//
// Author: Ruan <ruans@kr8.co.za>, (C) 2008
//
// Copyright: Do what you want, whenever you want.
//
//
#include "yawpconfig.h"
#include "yawp.h"
#include "yawpwday.h"

//-----------------------------------------------------------------------------
YaWPConfigDialog::YaWPConfigDialog(YaWP * applet) {

    QWidget * widget = new QWidget(this );
    setupUi( widget );
    setCaption( "YaWP" );
    setMainWidget( widget );
    connect( this, SIGNAL( buttonClicked( KDialog::ButtonCode ) ), this, SLOT( buttonClicked( KDialog::ButtonCode ) ) );
	m_applet = applet;
}


//-----------------------------------------------------------------------------
YaWPConfigDialog::~YaWPConfigDialog() {
    m_applet = NULL;
}


//-----------------------------------------------------------------------------
void YaWPConfigDialog::setInterval(int inter){
    QString text = QString("%1").arg(inter);
    for(int i = 0; i < comboInterval->count(); i++)
    {
        if(comboInterval->itemText(i) == text)
            comboInterval->setCurrentIndex(i);
    }
}


//-----------------------------------------------------------------------------
int YaWPConfigDialog::interval() const {
    return comboInterval->currentText().toInt();
}


//-----------------------------------------------------------------------------
void YaWPConfigDialog::setTheme(QString theme) {
    for(int i = 0; i < comboTheme->count(); i++)
        if(comboTheme->itemText(i) == theme)
            comboTheme->setCurrentIndex(i);
}


//-----------------------------------------------------------------------------
QString YaWPConfigDialog::theme() const {
    return comboTheme->currentText();
}


//-----------------------------------------------------------------------------
void YaWPConfigDialog::setCity(QString city) {
    editCity->setText(city);
}


//-----------------------------------------------------------------------------
QString YaWPConfigDialog::city() const {
    return editCity->text();
}


//-----------------------------------------------------------------------------
void YaWPConfigDialog::setCountry(QString country) {
    editCountry->setText(country);
}


//-----------------------------------------------------------------------------
QString YaWPConfigDialog::country() const {
    return editCountry->text();
}


//-----------------------------------------------------------------------------
void YaWPConfigDialog::setUnits(int units) {
    QString text;
    switch(units){
        case YaWPDay::IMPERIAL:
            text = "Imperial";
            break;
        case YaWPDay::METRIC:
            text = "Metric";
            break;
        default:
            text = "Metric";
    }
    for(int i = 0; i < comboUnits->count(); i++)
        if(comboUnits->itemText(i) == text)
            comboUnits->setCurrentIndex(i);
}


//-----------------------------------------------------------------------------
int YaWPConfigDialog::units() const {
    if(comboUnits->currentText() == "Imperial")
        return YaWPDay::IMPERIAL;
    if(comboUnits->currentText() == "Metric")
        return YaWPDay::METRIC;
    return YaWPDay::METRIC;
}


//-----------------------------------------------------------------------------
void YaWPConfigDialog::buttonClicked( KDialog::ButtonCode button ) {
    switch ( button ) {
    case KDialog::Ok:
        emit save();
        hide();
    case KDialog::Cancel:
        hide();
        break;
    case KDialog::Apply:
        emit save();
        break;
    default:
        break;
    }
}


